// This file was generated by Dashcode from Apple Inc.
// You may edit this file to customize your Dashboard widget.

//
// Function: load()
// Called by HTML body element's onload event when the widget is ready to start
//
function load()
{
	document.getElementById("versionString").innerText = "1.0";
	var updateTimerDisplayInterval = null;
    var decimals = 2;
    var prefixSDDisplay = false;
    setupParts();
    loadprefs();
//	widget.setPreferenceForKey(preference, key);
//	widget.preferenceForKey(key);
    if (updateTimerDisplayInterval == null) 
		updateTimerDisplayInterval = setInterval(computeSD, 10);
}

//
// Function: remove()
// Called when the widget has been removed from the Dashboard
//
function remove()
{
    // Stop any timers to prevent CPU usage
    // Remove any preferences as needed
    if (updateTimerDisplayInterval != null) {
        clearInterval(updateTimerDisplayInterval);
        updateTimerDisplayInterval = null;
    }
}

//
// Function: hide()
// Called when the widget has been hidden
//
function hide()
{
    // Stop any timers to prevent CPU usage
    if (updateTimerDisplayInterval != null) {
        clearInterval(updateTimerDisplayInterval);
        updateTimerDisplayInterval = null;
    }
}

//
// Function: show()
// Called when the widget has been shown
//
function show()
{
    // Restart any timers that were stopped on hide
    if (updateTimerDisplayInterval == null) 
		updateTimerDisplayInterval = setInterval(computeSD, 10);
}

//
// Function: sync()
// Called when the widget has been synchronized with .Mac
//
function sync()
{
    // Retrieve any preference values that you need to be synchronized here
    // Use this for an instance key's value:
    // instancePreferenceValue = widget.preferenceForKey(null, createInstancePreferenceKey("your-key"));
    //
    // Or this for global key's value:
    // globalPreferenceValue = widget.preferenceForKey(null, "your-key");
}

//
// Function: showBack(event)
// Called when the info button is clicked to show the back of the widget
//
// event: onClick event from the info button
//
function showBack(event)
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToBack");
    }

    front.style.display = "none";
    back.style.display = "block";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
}

//
// Function: showFront(event)
// Called when the done button is clicked from the back of the widget
//
// event: onClick event from the done button
//
function showFront(event)
{
	widget.setPreferenceForKey(document.getElementById("decimalsDD").selectedIndex, "decimals");
	widget.setPreferenceForKey(document.getElementById("prefixSDDisplayCB").checked, "prefixSDDisplay");
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget) {
        widget.prepareForTransition("ToFront");
    }

    front.style.display="block";
    back.style.display="none";

    if (window.widget) {
        setTimeout('widget.performTransition();', 0);
    }
	computeSD();
}

// Function: trunk(number, digits)
// Truncates number to digits decimals
function trunk(num, fixed) {
    var re = new RegExp('^-?\\d+(?:\.\\d{0,' + (fixed || -1) + '})?');
    return num.toString().match(re)[0];
}

// Function: computeSD()
// Updates SD strings.
function computeSD() {

    decimals = document.getElementById("decimalsDD").selectedIndex;

    prefixSDDisplay = document.getElementById("prefixSDDisplayCB").checked;

	timeNow = new Date();

	timeNowMilli = timeNow.getTime();

	// UTC correction
	diffUTCTime = timeNow.getTimezoneOffset() * 60000;
	timeNowMilli = timeNowMilli + diffUTCTime;
			
	// ** Common **
	// millsecInQCYear is the number of milliseconds in 
	// a standard quadcent year.
	millisecInQCYear = 31556952000;
		
	// millisecInYear is the number of milliseconds in
	// a gregorian year.
	millisecInYear = 31536000000;

	// ** TNG style SD **

	// prefixSDTNGZero is the starting prefix for TNG style
	// stardates, which is [21] 00000.00.
	prefixSDTNGZero = 21;

	// timeSDTNGZero is the date when the TNG style stardates
	// begin, january 1st, 2323. It is a date coinciding in
	// both quadcent and gregorian calendars.
	timeSDTNGZero = new Date(2323,0,1);
	timeSDTNGZeroMilli = timeSDTNGZero.getTime();

	// Compute the time difference between reference and now.
	timeBetweenTNG = timeNowMilli - timeSDTNGZeroMilli;

	// rawSDTNG is not really a SD since it's prefix and SD 
	// difference concatenated. The formula is simple:
	// 1000 SD units == 1 quadcent year, 
	// 1 quadcentyear == 31556952 seconds,
	// so SD value for the difference is:
	rawSDTNG = timeBetweenTNG * 1000 / millisecInQCYear;

	// refinedSDTNG is the real SD value.
	// As rawSDTNG is a difference, if rawSDTNG is positive
	// the real SD value is the modulo , if rawSDTNG is
	// negative, 100000 is added to the modulo, as rawSDTNG is a
	// difference (and is the complement to 100000 of
	// the real SD). 
	if (rawSDTNG < 0)
		refinedSDTNG = 100000 + rawSDTNG % 100000;
	else
		refinedSDTNG = rawSDTNG % 100000
	displaySDTNG = trunk(refinedSDTNG, decimals);
			
	// Fills up empty zeroes if the SD is less than 5 digits.
	if (refinedSDTNG >=10000)
		displaySDTNGString = displaySDTNG;
	else
	if (refinedSDTNG < 10)
		displaySDTNGString = "0000" + displaySDTNG;
	else
	if (refinedSDTNG < 100)
		displaySDTNGString = "000" + displaySDTNG;
	else
	if (refinedSDTNG < 1000)
		displaySDTNGString = "00" + displaySDTNG;
	else
	if (displaySDTNG < 10000)
		displaySDTNGString = "0" + displaySDTNG;

	// diffPrefixSDTNG is the difference in the SD prefix.
	diffPrefixSDTNG = Math.floor(rawSDTNG / 100000);

	// The real SD prefix.
	prefixSDTNG = prefixSDTNGZero + diffPrefixSDTNG;

	// The SD string.
	if (prefixSDDisplay == true)
		document.getElementById("SDTNG").innerText = "[" + prefixSDTNG + "]" + displaySDTNGString;
	else
		document.getElementById("SDTNG").innerText = displaySDTNGString;


	// ** TOS style SD **

	// timeSDTOSZeroMilli is the date when the TOS style stardates
	// begin, january 4th, 2162. 
	timeSDTOSZero = new Date(2162,0,4)
	timeSDTOSZeroMilli = timeSDTOSZero.getTime()

	// Compute the time difference between reference and now.
	timeBetweenTOS = timeNowMilli - timeSDTOSZeroMilli;

	// rawSDTOS is not a SD either since it's prefix and SD 
	// difference concatenated (as in TNG style). The formula is 
	// similar:
	// 5 SD units == 1 day,
	// => 1825 SD units == 1 year, 
	// 1 year == 31536000 seconds,
	// so SD value for the difference is:
	rawSDTOS = timeBetweenTOS * 1825 / millisecInYear;

	// refinedSDTOS is the real SD value.
	// As rawSDTOS is a difference, if rawSDTOS is positive
	// the real SD value is the modulo , if rawSDTOS is
	// negative, 10000 is added to the modulo, as rawSDTOS is a
	// difference (and is the complement to 10000 of
	// the real SD). 
	if (rawSDTOS < 0)
		refinedSDTOS = 10000 + rawSDTOS % 10000;
	else
		refinedSDTOS = rawSDTOS % 10000;
				
	displaySDTOS = trunk(refinedSDTOS, decimals);

	// Fills up empty zeroes if the SD is less than 4 digits.
	if (refinedSDTOS >=1000)
		displaySDTOSString = displaySDTOS;
	else
	if (refinedSDTOS < 10)
		displaySDTOSString = "000" + displaySDTOS;
	else
	if (refinedSDTOS < 100)
		displaySDTOSString = "00" + displaySDTOS;
	else
	if (refinedSDTOS < 1000)
		displaySDTOSString = "0" + displaySDTOS;

	// prefixSDTOS is the difference in the SD prefix, and actually
	// the real prefix, since the initial prefix is 0.
	prefixSDTOS = Math.floor(rawSDTOS / 10000);

	// The SD string.
	if (prefixSDDisplay == true)
		document.getElementById("SDTOS").innerText = "[" + prefixSDTOS + "]" + displaySDTOSString;
	else
		document.getElementById("SDTOS").innerText = displaySDTOSString;
}

function loadprefs() {
    decimals = widget.preferenceForKey("decimals"); 
    if (decimals == null) 
        document.getElementById("decimalsDD").selectedIndex = 2;
    prefixSDDisplay = widget.preferenceForKey("prefixSDDisplay");
    if (prefixSDDisplay == null) 
        document.getElementById("prefixSDDisplayCB").checked = false;
}

if (window.widget) {
    widget.onremove = remove;
    widget.onhide = hide;
    widget.onshow = show;
    widget.onsync = sync;
}
